#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "bc2_ex.h"
#include "bc2_util.h"

static char *error_msg[]={
"",
"#define ER_LVALUE_IS_CONST		1",
"#define ER_UNACCEPTED_OPRATION	2",
"#define ER_UNDEF_VARIABLE		3",
"#define ER_EXPECT_NUMBER		4",
"#define ER_SUBST_IN_FUNCTION	5",
"#define ER_PARAMETER_IS_CONST	6",
"#define ER_UNACCEPTED_CHARACTER	7",
"#define ER_STACK_UNDER_FLOW		8",
"#define ER_UNDEF_FUNCTION		9",
"#define ER_LESS_PARAMETER		10",
"#define ER_NOT_RIGHT_PAREN		11",
"#define ER_DIVIDE_BY_ZERO		12",
"#define ER_MODULO_BY_ZERO		13",
"#define ER_DOMAIN				14",
"#define ER_UNACCEPTED_OPRATION_RIGHT	15",
"#define ER_UNACCEPTED_OPRATION_LEFT	16",

};

int main(void)
{
	char str[4096];
	char res[256];
	char *end;
	int i;

	bc2_init();

	while(fgets(str, sizeof(str), stdin) != NULL)
	{
		i=strlen(str);
		i--;
		while(str[i] == 0x0a || str[i] == 0x0d)
		{
			str[i]=0;
			i--;
		}

		i=bc2_util_function(str, &end, res);
		if(i)
		{
			if(end == NULL)
				printf("end is NULL\n");
			else
			{
				if(end != str)
					printf("%*c", end-str, ' ');	
				puts("^ error\n");
			}
			puts(error_msg[i]);
		}
		else
			puts(res);
		puts("");
		fflush(stdout);
	}

	return 0;
}

