#ifndef BCLEX_H
#define BCLEX_H

#include "bc2_ex.h"

#define TYPE_PLUS		0		/* + */
#define TYPE_MINUS		1		/* - */
#define TYPE_MUL		2		/* * */
#define TYPE_DIV		3		/* / */
#define TYPE_MOD		4		/* % */
#define TYPE_POWER		5		/* ** */
#define TYPE_COMMA		6		/* , */
#define TYPE_EQ			7		/* = */

#define TYPE_OR			8
#define TYPE_AND		9
#define TYPE_XOR		10
#define TYPE_LSHIFT		11
#define TYPE_RSHIFT		12
#define TYPE_NOT		13

/* 14 ` 19 JĂ */

#ifndef TYPE_FLOAT
#define TYPE_FLOAT		20
#endif

#ifndef TYPE_INTEGER
#define TYPE_INTEGER	21
#endif

#define TYPE_VARIABLE	22


#ifndef TYPE_FUNCTION
#define TYPE_FUNCTION	23
#endif

#define TYPE_LPAR		24
#define TYPE_RPAR		25


#define TYPE_UNDEF_VARIABLE	26
#define TYPE_PARAMETER	27
#define TYPE_EOS		28		/* end of string */
#define TYPE_OTHER		29		/* unaccepted character */


/*
struct int_s{
	unsigned long i;
	long sign;
};

union num_u{
	myfloat f;
	struct int_s integer;
};

*/

struct lex_s{
	int type;

	union lex_data_u{
		union num_u num;
		char *id;
	}data;

	struct variable_s *variable;
	char *aux;
};

extern struct lex_s lex;


void lex_next(void);
void lex_init(char *str);
char *lex_get_lex_begin(void);
void lex_set_lex_begin(char * const p);



#endif

