#ifndef MACHINE_H
#define MACHINE_H
/* long double g */
//#define USE_LONG_DOUBLE

#ifdef RUPUTER
typedef double myfloat;
#undef USE_LONG_DOUBLE

void rup_func_add_menu(char * const name);
void rup_vari_add_menu(char * const name);

#include "../librup/power.h"
#include "../librup/my_dtoa.h"
#include "../librup/mystrtod.h"
#include "../librup/my16ultoa.h"
#include "../librup/myultoa.h"


#define strtod my_strtod
#define pow	power

#else /* RUPUTER */

#ifdef USE_LONG_DOUBLE
  #include "longdouble/ldtoa.h"
  #define strtod _strtold
  typedef long double myfloat;

#else // ! USE_LONG_DOUBLE
  typedef double myfloat;
#endif


#define ENABLE_FUNCTION_TO_STRING
#ifdef ENABLE_FUNCTION_TO_STRING
void function_to_string(char *str);
#endif

#define ENABLE_VARIABLE_TO_STRING
#ifdef ENABLE_VARIABLE_TO_STRING
void variable_to_string(char *str);
#endif

#endif /* endif RUPUTER */


/*
#define DEBUG_OUTPUT
*/

#endif

