#ifndef UNDER_CE
#include <stdio.h>
#endif

#include <stdlib.h>
#include <string.h>

#include "bc2_ex.h"
#include "stack.h"
#include "machine.h"

void integer_to_string(struct stack_s * const s, char *str)
{
	if(s->num.integer.i == 0)
		strcpy(str, "0");
	else
	{
#ifdef RUPUTER
		int i;
		int exp;
		char *p;
		char *q;

		p=str;

		if(s->num.integer.sign == MINUS)
			*p++='-';
		q=p;
		my_ultoa(s->num.integer.i, p);
		i=strlen(p);
		exp=i-1;
		p+=i;
		*p++=' ';

/* e hyoki */

		if(s->num.integer.sign == MINUS)
			*p++='-';
		*p++=*q;
#if 0
/* _ȉ */
		if(exp > 0)
			*++p='.';
		while((*++p=*++q) != ' ')
			;
#endif
		*p++='e';
		my_ultoa(exp, p);

		i=strlen(p);
		p+=i;
		while(p-str < 37)
			*p++=' ';

		my_16_ultoa(s->num.integer.i, p);
#else
		double d;	/* unsigned long Ȃ̂ŁAdouble ł */

		if(s->num.integer.sign == MINUS)
			*str++='-';

		d=s->num.integer.i;
		if(s->num.integer.sign == MINUS)
			d=-d;
		sprintf(str, "%lu(0x%lx)(%.10e)", s->num.integer.i, s->num.integer.i, d);
#endif
	}
}
void num_to_string(struct stack_s * const s, char *str)
{
	switch(s->type)
	{
	case TYPE_INTEGER:
		integer_to_string(s, str);
		break;
	case TYPE_FLOAT:
#ifdef RUPUTER

		{
			int i;

			my_dtoa(s->num.f, str);

			i=strlen(str);
			str+=i;
			while(i++ <= 37)
				*str++=' ';
			*str=0;
		}
#else // !RUPUTER

# ifdef USE_LONG_DOUBLE
		{
			char *p;

			p=_ldtoa_r(s->num.f, 0, 24, NULL, NULL, NULL);
			strcpy(str, p);
		}
# else //! USE_LONG_DOUBLE

#  if UNDER_CE == 200
#error "not exist (?) float to string function"

#  else
		sprintf(str, "%.20e(%f)", s->num.f, s->num.f);
#  endif


# endif //! USE_LONG_DOUBLE

#endif // !RUPUTER
	}
}

