#ifndef VARIABLE_H
#define VARIABLE_H

#include "lex.h"
#include "stack.h"

struct variable_s{
	int type;
	union num_u num;
	char *name;
	struct variable_s *next;
};

struct variable_s *variable_get(char * const id);
void variable_set(char * const id, struct stack_s * const v);


#endif
