/* powered by Haruhiko Okumura */
#include <stdlib.h>
#include <limits.h>
#include <math.h>

#include "power.h"
#include "ipower.h"
#ifndef INT_MAX
 #define INT_MAX 0x7fff	/* equal with short */
#endif

double power(double x, double y)  /* ݏ */
{
	if (y <= INT_MAX && y >= -INT_MAX && y == (int)y)
		return ipower(x, y);
	if (x > 0)
		return exp(y * log(x));

	return 0;
}


