#ifndef CODE_H
#define CODE_H

#include "lex.h"
#include "stack.h"

void free_code(void);
void init_code(void);
char *run_code(void);
void add_code(int op, struct lex_s * const _lex);
void code_to_string(struct lex_s *c, int count, char *str);

void conv_integer_to_float(struct stack_s * const s);


extern int code_count;
extern struct lex_s *code;

#endif
