#ifndef UNDER_CE
#include <stdio.h>
#endif

#include <stdlib.h>
#include <string.h>

#ifdef RUPUTER
#include <psdos.h>
#include <lcdbios.h>
#endif

char alloc_error_msg[]="alloc error";

/*** misc. **********************************************************/
void error_exit(char * const str)
{
#ifdef RUPUTER
	if(str)
		gv_kput(0, 0, str, 0, 0, 0);
	dos_exit(1);
#else // !RUPUTER

# ifndef UNDER_CE
	if(str)
		fprintf(stderr, "error_exit : %s\n", str);
# endif

	exit(1);
#endif
}

void *my_malloc(size_t size)
{
	void *p;

	p=malloc(size);
	if(p == NULL)
		error_exit(alloc_error_msg);
	return p;
}

void *my_realloc(void * const prev, size_t size)
{
	void *p;

	p=realloc(prev, size);
	if(p == NULL)
		error_exit(alloc_error_msg);
	return p;
}

