
#include <stdio.h>
#include <stdlib.h>

#include "ipower.h"

double ipower(double x, int n)  /*  */
{
	int abs_n;
	double r;

	abs_n = abs(n);
	r = 1;

	while(abs_n != 0)
	{
		if(abs_n & 1)
			 r *= x;
		x *= x;
		abs_n >>= 1;
	}

	return (n >= 0 ? r : 1/r);
}


