
#ifndef SHMENU_H
#define SHMENU_H
#include "menu.h"
#include "shcalc.h"

#define MENU_END (menu_end[0].str)
#define MENU_KEISAN (menu_root[0].str)

static win_menu menu_gyakusankaku[]={
	{"asin(", NULL},
	{"acos(", NULL},
	{"atan(", NULL},
	{NULL, NULL},
};
static win_menu menu_sankaku[]={
	{"sin(", NULL},
	{"cos(", NULL},
	{"tan(", NULL},
#ifndef ENGLISH
	{"t֐", menu_gyakusankaku},
#else
	{"inverse", menu_gyakusankaku},
#endif
	{NULL, NULL},
};

static win_menu menu_gyakusoukyoku[]={
	{"asinh(", NULL},
	{"acosh(", NULL},
	{"atanh(", NULL},
	{NULL, NULL},
};

static win_menu menu_soukyoku[]={
	{"sinh(", NULL},
	{"cosh(", NULL},
	{"tanh(", NULL},
#ifndef ENGLISH
	{"t֐", menu_gyakusoukyoku},
#else
	{"inverse", menu_gyakusoukyoku},
#endif
	{NULL, NULL},
};

static win_menu menu_sisutaisu[]={
	{"exp(", NULL},
	{"log(", NULL},
	{"ln(", NULL},
	{"log10(", NULL},
	{"sqrt(", NULL},
	{NULL, NULL},
};

static win_menu menu_other_function[]={
	{"d2r(", NULL},
	{"r2d(", NULL},
	{"abs(", NULL},
	{"fact(", NULL},
	{NULL, NULL},
};
win_menu menu_all_function[]={
#ifndef ENGLISH
	{"o^֐", NULL},
	{"wΐ", menu_sisutaisu},
	{"Op֐", menu_sankaku},
	{"oȐ", menu_soukyoku},
	{"̑", menu_other_function},
#else
	{"user", NULL},
	{"exp log", menu_sisutaisu},
	{"trig", menu_sankaku},
	{"hyp", menu_soukyoku},
	{"other", menu_other_function},
#endif
	{NULL, NULL},
};

#ifdef RECALL_SYSTEM
win_menu menu_recall[NUM_RESULT+1];
/*
={
	{NULL, NULL},
	{NULL, NULL},
	{NULL, NULL},
	{NULL, NULL},
	{NULL, NULL},
};
*/
#endif

win_menu menu_end[]={
#ifndef ENGLISH
	{"I", NULL},
#else
	{"end", NULL},
#endif
	{NULL, NULL},
};
win_menu menu_root[]={
#ifndef ENGLISH
	{"vZ", NULL},
	{"ϐ", NULL},
	{"֐", menu_all_function},
#ifdef RECALL_SYSTEM
	{"", menu_recall},
#endif
	{"I", menu_end},
#else
	{"evaluate", NULL},
	{"variable", NULL},
	{"function", menu_all_function},
#ifdef RECALL_SYSTEM
	{"result", menu_recall},
#endif
	{"end", menu_end},
#endif /* ENGLISH */
	{NULL, NULL},
};

#endif
